﻿using System;
using System.Data;

namespace WHDG.DecimalPoint
{
    public partial class Default : System.Web.UI.Page
    {
        private static DataSet ds;

        public Default()
        {
            if (ds == null) ds = GetDataSource();
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            whdg.DataSource = ds;
            whdg.DataBind();
        }

        private DataSet GetDataSource()
        {
            DataSet ds = new DataSet("Set");

            ds.Tables.Add(GetParentData());
            ds.Tables.Add(GetChildData());
            ds.Relations.Add(ds.Tables["ParentTable"].Columns["ID"], ds.Tables["ChildTable"].Columns["ParentID"]);

            return ds;
        }

        public DataTable GetParentData()
        {
            DataTable dt = new DataTable("ParentTable");
            dt.Columns.Add("ID", typeof(int));
            dt.Columns.Add("Category", typeof(string));
            dt.Columns.Add("Value", typeof(double));
            dt.Columns.Add("TAXRATE", typeof(double));

            string[] Categories = { "Category A", "Category B", "Category C", "Category D" };
            Random rnd = new Random();

            for (int i = 0; i < 10; i++)
            {
                string category = Categories[rnd.Next(0, 4)];
                dt.Rows.Add(new object[] { i, category, rnd.NextDouble(), rnd.Next(1000, 3000) });
            }
            return dt;
        }

        public DataTable GetChildData()
        {
            DataTable dt = new DataTable("ChildTable");
            dt.Columns.Add("ID", typeof(int));
            dt.Columns.Add("ParentID", typeof(int));
            dt.Columns.Add("SubCategory", typeof(string));
            dt.Columns.Add("Value", typeof(double));
            dt.Columns.Add("TAXRATE", typeof(double));

            string[] Categories = { "Category 1", "Category 2", "Category 3", "Category 4" };
            Random rnd = new Random();

            for (int i = 0; i < 10; i++)
            {
                string category = Categories[rnd.Next(0, 4)];
                dt.Rows.Add(new object[] { i + 20, rnd.Next(0, 10), category, rnd.NextDouble(), rnd.Next(0, 10) });
            }

            return dt;
        }

        protected void whdg_InitializeRow(object sender, Infragistics.Web.UI.GridControls.RowEventArgs e)
        {
            if ((string)e.Row.Items.GetValue(1) == "Category C")
            {
                    e.Row.Items[2].Text = string.Format("{0:N5}", e.Row.Items[2].Value);
            }
        }
    }
}